routes/web.php
<?php

Route::get('/', function () {
    return redirect('/login');
});

Auth::routes();

Route::group([
    'prefix' => 'needs',
], function () {
    Route::get('/', 'NeedController@index')->name('needs.index')->middleware('is-worker');
    Route::get('/create', 'NeedController@create')->name('needs.create');
    Route::get('/{id}', 'NeedController@show')->name('needs.show')->middleware('is-worker');
    Route::post('/', 'NeedController@store')->name('needs.store');
    Route::post('/{id}', 'NeedController@update')->name('needs.update')->middleware('is-worker');
    Route::get('/{id}/edit', 'NeedController@edit')->name('needs.edit')->middleware('is-worker');
});

Route::group([
    'prefix' => 'volunteers',
], function () {
    Route::get('/', 'VolunteerController@index')->name('volunteers.index')->middleware('is-worker');
    Route::post('/', 'VolunteerController@store')->name('volunteers.store');
    Route::get('/create', 'VolunteerController@create')->name('volunteers.create');
    Route::get('/{id}', 'VolunteerController@show')->name('volunteers.show')->middleware('is-worker');
    Route::post('/{id}', 'VolunteerController@update')->name('volunteers.update')->middleware('is-worker');
    Route::get('/{id}/edit', 'VolunteerController@edit')->name('volunteers.edit')->middleware('is-worker');
});

Route::group([
    'prefix' => 'group-volunteers',
], function () {
    Route::get('/', 'GroupVolunteerController@index')->name('group_volunteers.index')->middleware('is-worker');
    Route::post('/', 'GroupVolunteerController@store')->name('group_volunteers.store');
    Route::get('/create', 'GroupVolunteerController@create')->name('group_volunteers.create');
    Route::get('/{id}', 'GroupVolunteerController@show')->name('group_volunteers.show')->middleware('is-worker');
    Route::post('/{id}', 'GroupVolunteerController@update')->name('group_volunteers.update')->middleware('is-worker');
    Route::get('/{id}/edit', 'GroupVolunteerController@edit')->name('group_volunteers.edit')->middleware('is-worker');
});

Route::group([
    'prefix' => 'urgent-needs',
], function () {
    Route::get('/', 'UrgentNeedController@index')->name('urgent_needs.index')->middleware('is-worker');
    Route::get('/create', 'UrgentNeedController@create')->name('urgent_needs.create')->middleware('is-worker');
    Route::get('/{id}', 'UrgentNeedController@show')->name('urgent_needs.show')->middleware('is-worker');
    Route::post('/', 'UrgentNeedController@store')->name('urgent_needs.store')->middleware('is-worker');
    Route::post('/{id}', 'UrgentNeedController@update')->name('urgent_needs.update')->middleware('is-worker');
    Route::get('/{id}/edit', 'UrgentNeedController@edit')->name('urgent_needs.edit')->middleware('is-worker');
});

Route::group([
    'prefix' => 'map',
    'middleware' => 'web'
], function () {
    Route::get('/', 'MapController@index')->name('map.index');
    Route::get('/needs', 'MapController@needs')->name('map.needs');
});

Route::group([
    'prefix' => 'users',
    'middleware' => 'is-admin'
], function () {
    Route::get('/', 'UserController@index')->name('users.index');
    Route::post('/', 'UserController@store')->name('users.store');
    Route::post('/update/{id}', 'UserController@update')->name('users.update');
    Route::post('/{id}/delete', 'UserController@destroy')->name('users.destroy');
});


Route::post('/print-needs', 'PrintNeedController@store')->name('print.needs');
Route::post('/print-stats', 'PrintNeedController@stats')->name('print.stats');
Route::get('/stats', 'StatController@index');
Route::get('/stats/show', 'StatController@show')->name('stats.show');
Route::post('/messages', 'MessageController@store');

app/Volunteer.php
<?php

namespace App;

use App\Helpers\PhoneNumber;

class Volunteer extends SuperModel
{
    protected $dates = ['date_available'];

    /**
     * @return string
     */
    public function getFullNameAttribute()
    {
        return $this->first_name . ' ' . $this->last_name;
    }

    /**
     * @param $phoneNumber
     */
    public function setPhoneAttribute($phoneNumber)
    {
        $this->attributes['phone'] = PhoneNumber::onlyNumbers($phoneNumber);
    }

    /**
     * @param $phoneNumber
     * @return string
     */
    public function getPhoneAttribute($phoneNumber)
    {
        return PhoneNumber::format($phoneNumber);
    }
}

app/Http/Controllers/VolunteerController.php
<?php

namespace App\Http\Controllers;

use App\Volunteer;
use Carbon\Carbon;

class VolunteerController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('volunteers.index', [
            'volunteers' => Volunteer::all()
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('volunteers.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @return \Illuminate\Http\Response
     */
    public function store()
    {
        request()->merge([
            'date_available' => Carbon::parse(request('date_available'))->toDateString()
        ]);

        Volunteer::create(request()->except('_token'));

        return response(['success' => true]);
    }

    /**
     * Display the specified resource.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        return view('volunteers.show', [
            'volunteer' => Volunteer::find($id)
        ]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        return view('volunteers.edit', [
            'volunteer' => Volunteer::find($id)
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function update($id)
    {
        $this->getCheckboxValues();

        Volunteer::find($id)->update(request()->except('_token'));

        return response(['success' => true]);
    }

    /**
     * We need to see if the checkboxes were POSTed. If not, then we need to set them to false.
     */
    public function getCheckboxValues()
    {
        request()->merge([
            'date_available' => Carbon::parse(request('date_available'))->toDateString(),
            'speaks_spanish' => request()->has('speaks_spanish') ? true : false,
            'debris_removal' => request()->has('debris_removal') ? true : false,
            'home_repair' => request()->has('home_repair') ? true : false,
            'deliveries' => request()->has('deliveries') ? true : false,
            'administrative' => request()->has('administrative') ? true : false,
            'sorting' => request()->has('sorting') ? true : false,
            'communications' => request()->has('communications') ? true : false,
            'counseling' => request()->has('counseling') ? true : false,
        ]);
    }
}

resources/views/volunteers/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <div class="col-sm-12 m-b-24">
                <h2>Individual Volunteer Form</h2>
                <p>Thank you for being interested in volunteering! This form is for individuals only. If you are a group
                    who is looking to help, please complete the Volunteer Group Form found at albanyreliefrecovery.com.
                    As we continue to assess the needs and help our community move toward recovery, this information
                    will be helpful in filling potential needs.</p>
            </div>
            <div class="col-sm-12">
                @include('partials.volunteers._form', ['route' => route('volunteers.store')])
            </div>
        </div>
    </div>

@endsection

@push('css')
<link rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.6.4/css/bootstrap-datepicker3.min.css">
@endpush

@push('js')
<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.6.4/js/bootstrap-datepicker.min.js"></script>
<script src="{{ asset('js/volunteers.bundle.js') }}"></script>
@endpush

resources/views/volunteers/edit.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <div class="col-sm-12 m-b-24">
                <h2>Individual Volunteer Form - {{ $volunteer->full_name }}</h2>
            </div>
            <div class="col-sm-12">
                @include('partials.volunteers._form', ['route' => route('volunteers.update', ['id' => $volunteer->id])])
            </div>
        </div>
    </div>
@endsection

@push('css')
<link rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.6.4/css/bootstrap-datepicker3.min.css">
@endpush

@push('js')
<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.6.4/js/bootstrap-datepicker.min.js"></script>
<script src="{{ asset('js/volunteers.bundle.js') }}"></script>
@endpush

resources/views/volunteers/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <div class="col-sm-12 m-b-24">
                <h2>Volunteers</h2>
            </div>
            <div class="col-sm-12">
                <div class="section-wrapper">
                    <div class="responsive-table-wrapper">
                        <table class="table table-striped table-hover table-condensed" id="volunteers-table">
                            <thead>
                            <tr>
                                <th>Name</th>
                                <th>Phone</th>
                                <th>Email</th>
                                <th>Start Date</th>
                                <th></th>
                            </tr>
                            </thead>
                            <tbody>
                            @foreach($volunteers as $volunteer)
                                <tr>
                                    <td>{{ $volunteer->full_name }}</td>
                                    <td>{{ $volunteer->phone }}</td>
                                    <td>{{ $volunteer->email }}</td>
                                    <td>{{ $volunteer->date_available->format(' F j') }}</td>
                                    <td>
                                        <div class="btn-group">
                                            <a href="{{ route('volunteers.show', ['id' => $volunteer->id]) }}"
                                               class="btn btn-sm btn-default"
                                               data-toggle="tooltip"
                                               data-placement="top"
                                               title="View Volunteer">
                                                <i class="fa fa-eye"></i>
                                            </a>
                                            <a href="{{ route('volunteers.edit', ['id' => $volunteer->id]) }}"
                                               class="btn btn-sm btn-primary"
                                               data-toggle="tooltip"
                                               data-placement="top"
                                               title="Edit Volunteer">
                                                <i class="fa fa-edit"></i>
                                            </a>
                                        </div>
                                    </td>
                                </tr>
                            @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

@push('css')
<link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/v/bs/dt-1.10.13/r-2.1.0/datatables.min.css"/>
@endpush

@push('js')
<script type="text/javascript" src="https://cdn.datatables.net/v/bs/dt-1.10.13/r-2.1.0/datatables.min.js"></script>
<script type="text/javascript" src="{{ asset('js/volunteers.bundle.js') }}"></script>
@endpush

resources/views/volunteers/show.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <div class="col-sm-8 col-sm-offset-2">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h2>Volunteer - {{ $volunteer->full_name }}</h2>
                    </div>
                    <table class="table table-striped table-hover">
                        <tbody>
                        <tr>
                            <td>Name:</td>
                            <td> {{ $volunteer->full_name }}</td>
                        </tr>
                        <tr>
                            <td>Phone:</td>
                            <td> {{ $volunteer->phone }}</td>
                        </tr>
                        <tr>
                            <td>Email:</td>
                            <td> {{ $volunteer->email or '' }}</td>
                        </tr>
                        <tr>
                            <td>Affiliation:</td>
                            <td>{{ $volunteer->affiliation }}</td>
                        </tr>
                        <tr>
                            <td>Preferred Type of Work</td>
                            <td>
                                <ul class="list-group">
                                    @if($volunteer->debris_removal)
                                        <li class="list-group-item">Manual Labor - Clean Up & Debri Removal</li>
                                    @endif

                                    @if($volunteer->home_repair)
                                        <li class="list-group-item">Manual Labor - Home Repair</li>
                                    @endif

                                    @if($volunteer->deliveries)
                                        <li class="list-group-item">Home Deliveries of Goods</li>
                                    @endif

                                    @if($volunteer->administrative)
                                        <li class="list-group-item">Secretarial Work (phone management, data entry,
                                            etc.)
                                        </li>
                                    @endif

                                    @if($volunteer->sorting)
                                        <li class="list-group-item">Sorting/Warehouse Management</li>
                                    @endif

                                    @if($volunteer->communications)
                                        <li class="list-group-item">Communication - Social Media</li>
                                    @endif

                                    @if($volunteer->counseling)
                                        <li class="list-group-item">Counseling Services</li>
                                    @endif

                                    @if($volunteer->other)
                                        <li class="list-group-item">{{ $volunteer->other }}</li>
                                    @endif
                                </ul>
                            </td>
                        </tr>
                        <tr>
                            <td>Resources Available</td>
                            <td>{{ $volunteer->resources_available }}</td>
                        </tr>
                        <tr>
                            <td>Time Commitment</td>
                            <td>{{ $volunteer->time_commitment }}</td>
                        </tr>
                        <tr>
                            <td>Speaks Spanish</td>
                            <td>{{ $volunteer->speaks_spanish }}</td>
                        </tr>
                        <tr>
                            <td>Date Available</td>
                            <td>{{ $volunteer->date_available->format('F j, y') }}</td>
                        </tr>
                        <tr>
                            <td>Additional Comments:</td>
                            <td> {{ $volunteer->additional_comments }}</td>
                        </tr>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
@endsection

@push('css')
@endpush

@push('js')
@endpush